script.on_init(function()
    global.descendants = {}

    for name, tech in pairs(game.technology_prototypes) do
        for pre, _ in pairs(tech.prerequisites) do
            global.descendants[pre] = global.descendants[pre] or {}

            table.insert(global.descendants[pre], tech.name)
        end
    end

    for _, name in ipairs(global.descendants["automation"]) do
        game.print(name)
    end
end)

script.on_event(defines.events.on_research_finished, function(e)
    local desc = global.descendants[e.research.name]

    if (desc) then
        local lines = {""}
        local msg = {"", {"rf-messages.rf-researched-message", e.research.localised_name}}
        for _, d in ipairs(desc) do
            local all_done = true
            for _, pre in pairs(e.research.force.technologies[d].prerequisites) do
                if not pre.researched then
                    all_done = false
                    break
                end
            end

            if all_done then
                e.research.force.technologies[d].enabled = true
                lines[#lines+1] = {"", e.research.force.technologies[d].localised_name, "\n"}
            end
        end

        msg[3] = lines

        e.research.force.print(msg, {0.3, 0.7, 0.1})
    end
end)